> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pipevest.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Report

> Creates trigger to generate reports



## OpenAPI

````yaml POST /reports
openapi: 3.0.0
info:
  title: Pipevest Investment API
  description: Connecting millions of Africans to the global economy
  version: 0.0.1
servers:
  - url: https://api.pipevest.com/v1
    description: Production server
  - url: https://api.staging.pipevest.com/v1
    description: Staging server
security:
  - BearerAuth: []
paths:
  /reports:
    parameters:
      - $ref: '#/components/parameters/Signature'
      - $ref: '#/components/parameters/SignatureInput'
      - $ref: '#/components/parameters/XCliendId'
    post:
      tags:
        - Reports
      summary: Creates trigger to generate reports
      parameters:
        - $ref: '#/components/parameters/ContentDigest'
        - $ref: '#/components/parameters/XIdempotencyKey'
      requestBody:
        description: Details used to create a reports trigger
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateReport'
      responses:
        '200':
          description: Details of a investment portfolio
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/Created'
                  - type: object
                    properties:
                      data:
                        $ref: '#/components/schemas/Report'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '404':
          $ref: '#/components/responses/NotFound'
components:
  parameters:
    Signature:
      in: header
      name: Signature
      schema:
        type: string
        example: 'sig1=:OTEyMjY4...A5NTNDMEQ=:'
        description: >
          Base64 encoded signed hash of the http message request components.


          [Learn how signatures
          work](/concepts/http-signature/message-signature)
      required: true
    SignatureInput:
      in: header
      name: Signature-Input
      schema:
        type: string
        example: sig1=("Content-Type" "Content-Digest"...expires=<expires>
        description: >
          An ordered list of components that make up the signature base. It is
          used to recompute and verify the `Signature`


          [Learn how signatures
          work](/concepts/http-signature/message-signature)
      required: true
    XCliendId:
      in: header
      name: X-Client-Id
      schema:
        $ref: '#/components/schemas/ClientId'
      example: client-id
      required: true
    ContentDigest:
      in: header
      name: Content-Digest
      schema:
        type: string
        example: 'sha-512=:RK/0qy18MlBSVnWgjwz6lZEWjP/lF5HF9bvEF8FabDg=:'
        description: >
          Base64 encoded sha-512 hash of the http message body.


          This key isn't not required for `GET` and `DELETE` requests.


          [Learn how to generate content
          digest](/concepts/http-signature/content-digest)
      required: true
    XIdempotencyKey:
      in: header
      name: X-Idempotency-Id
      schema:
        type: string
        example: 01937261-e216-754f-99ba-c1170d65dd28
        description: >
          Unique identifier passed into each a mutable request (i.e `POST`,
          `PUT`, `PATCH`, `DELETE`)


          This key isn't not required for `GET` requests
      required: true
  schemas:
    CreateReport:
      type: object
      description: >
        Report Payload


        Refer to [Report documentation](https://docs.pipevest.com) to understand
        how reports work
      properties:
        reportTypes:
          $ref: '#/components/schemas/ReportTypes'
        url:
          $ref: '#/components/schemas/WebhookUrl'
        email:
          $ref: '#/components/schemas/Email'
      required:
        - reportTypes
    Created:
      allOf:
        - $ref: '#/components/schemas/Success'
        - type: object
          properties:
            code:
              allOf:
                - $ref: '#/components/schemas/ResponseCode'
                - example: 201
            message:
              allOf:
                - $ref: '#/components/schemas/ResponseMessage'
                - example: Created
    Report:
      type: object
      properties:
        reportId:
          $ref: '#/components/schemas/ReportId'
        reportTypes:
          $ref: '#/components/schemas/ReportTypes'
        status:
          $ref: '#/components/schemas/ReportStatus'
        url:
          $ref: '#/components/schemas/WebhookUrl'
        email:
          $ref: '#/components/schemas/Email'
        createdAt:
          $ref: '#/components/schemas/CreatedAt'
        updatedAt:
          $ref: '#/components/schemas/UpdatedAt'
      required:
        - reportId
        - reportTypes
        - createdAt
        - updatedAt
    ClientId:
      description: Unique identifier assigned to the client
      type: string
      example: client-id
    ReportTypes:
      type: array
      description: List of report types
      items:
        $ref: '#/components/schemas/ReportType'
    WebhookUrl:
      description: A valid https url
      type: string
      example: https://companyx.com/webhooks
    Email:
      description: A valid email
      type: string
      example: reports@companyx.com
    Success:
      type: object
      properties:
        data:
          oneOf:
            - type: object
            - type: array
        code:
          $ref: '#/components/schemas/ResponseCode'
        message:
          $ref: '#/components/schemas/ResponseMessage'
      required:
        - data
        - code
        - message
    ResponseCode:
      description: Request response code
      type: string
      example: 200
    ResponseMessage:
      description: Request response message
      type: string
      example: Success
    ReportId:
      description: Unique report identifier
      type: integer
      example: 123456
    ReportStatus:
      description: Current status of the report
      enum:
        - PROCESSING
        - COMPLETED
        - ERROR
      example: PROCESSING
    CreatedAt:
      description: Created at unix timestamp
      type: integer
      example: 1234567890
    UpdatedAt:
      description: Updated at unix timestamp
      type: integer
      example: 1234567890
    Error:
      type: object
      properties:
        code:
          allOf:
            - $ref: '#/components/schemas/ResponseCode'
            - example: 401
        message:
          allOf:
            - $ref: '#/components/schemas/ResponseMessage'
            - example: Unauthorized
      required:
        - code
        - message
    ReportType:
      description: The type of report
      enum:
        - USER
        - TRANSACTION
        - REGULATORY
      example: REGULATORY
  responses:
    Unauthorized:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    NotFound:
      description: The specified resource was not found
      content:
        application/json:
          schema:
            allOf:
              - $ref: '#/components/schemas/Error'
              - type: object
                properties:
                  code:
                    type: string
                    example: 404
                  message:
                    type: string
                    example: Not Found
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````